# Solar System

## About This Project

An approximate visualisation of the bodies in our solar system. Asteroid
positions are computed from Minor Planet Center orbit determination. No
perturbations are applied to the orbits - calculations assume asteroids are in
elliptical orbits around the sun - so they are inaccurate when simulating far in
the future or past.

Full code for this project is available on
[GitHub](https://github.com/alex-kennedy/solar-system) and is freely licensed
under the [MIT
License](https://github.com/alex-kennedy/solar-system/blob/main/LICENSE).

## References

- Asteroid orbits are from the [International Astronomical Union Minor Planet Center](https://www.minorplanetcenter.net/data).

- Stellar positions are from the [Yale Bright Star Catalog](http://tdc-www.harvard.edu/catalogs/bsc5.html).

- Planetary (and Pluto) orbits are computed from [JPL Solar System Dynamics](https://ssd.jpl.nasa.gov/?planet_phys_par).

- [Orbital Mechanics, Wikipedia](https://en.wikipedia.org/wiki/Orbital_mechanics)

- Curtis, Howard D. 2019. _Orbital Mechanics for Engineering Students: Revised Fourth Edition._ ISBN 978-0-08-102133-0.
